theory Motivation
imports
  Main
  "~~/src/HOL/Decision_Procs/Parametric_Ferrante_Rackoff"
  "~~/src/HOL/Decision_Procs/Reflected_Multivariate_Polynomial"
  "~~/src/HOL/Decision_Procs/Commutative_Ring"
  "~~/src/HOL/Library/Polynomial"
  "~~/src/HOL/Algebra/UnivPoly"
begin

text {*
  The Isabelle distribution \cite{NipkowKlein2014CS} and the
  Archive of Formal Proof already contain various formal developments
  about polynomials; abstract developments include the following.
  
  \begin{description}

    \item[Locales] \label{enum:poly:meta}A hierarchy of algebraic modules (theory @{theory UnivPoly})
      features an abstract construction of univariate polynomials.
      It has been designed for abstract algebraic reasoning.
  
    \item[Type] \label{enum:poly:type}The type @{typ [source] "'a poly"} (theory @{theory Polynomial})
      for univariate polynomials over an algebraic
      structure @{typ "'a"} covers both both abstract properties and concrete computations on polynomials.
      Advanced notions like polynomial division, polynomial derivation and the fundamental theorem of algebra are also available.
    
    \item[Application-specific developments] \label{enum:poly:app}
      \renewcommand{\isacharunderscore}{\hyp}%
      Various fragments of polynomial theory are tailored to their particular application.
      They include Gröbner bases
      (theory @{theory Groebner_Basis}), Ferrante and Rackoff's procedure with polynomial parameters
      (theory @{theory Parametric_Ferrante_Rackoff}), reflected decision procedures
      (theories @{theory Reflected_Multivariate_Polynomial}, @{theory Commutative_Ring}), and
      a particular executable representation of multivariate polynomials \cite{Polynomials-AFP}.
  \end{description}

  What is unsatisfactory is the non-integration of all these formalisations: there are no
  definitions or lemmas which relate the different approaches.
  For example, each of the application-specific formalisations develops polynomial theory from scratch, without relation to a common base.
  
  The type-based approach can express multivariate polynomials using type nesting.
  For example, @{typ [source] "'a poly poly poly"} denotes a polynomial over three variables (although some variables might occur only with exponent $0$).
  Nevertheless, @{typ [source] "'a poly"} cannot serve as a common base, as it cannot express the concept of a multivariate polynom with an arbitrary number of variables.
  HOL's type system cannot express arbitrary type nesting @{text "'a poly\<^sup>n"}.
  Hence, we cannot formulate typical algorithms from computer algebra (CA) for arbitrary numbers of variables.
  We cannot even express a parse function that takes the string representation of a polynomial
with an arbitrary number of variables and returns the corresponding polynomial.

  Therefore, we have started to collect the CA requirements (\S\ref{goals}) and to develop a type for multivariate polynomials (\S\ref{PP-structure}).
  The type approach is very suitable for formulating algorithms at an abstract level and generating executable code on efficient representations.
  The development currently is at an early stage, and the current design fails to address all requirements.
  In \S\ref{probl-quest}, we discuss the problems and open questions.
*}

end
